<?php

use SHD\Smview\Connect\Service\DB\DaoUtil;

/**
 * i-doit
 *
 * Applications API for SM-VIEW Connect.
 *
 * @package     i-doit
 * @subpackage  smview_connect
 * @author      Florian Weber <florian.weber@shd-online.de>
 * @copyright   2023 SHD System-Haus-Dresden GmbH
 * @license     http://www.i-doit.com/license
 */
class connect_api_model_applications extends isys_api_model_cmdb implements isys_api_model_interface
{
    public function read($p_params)
    {
        if ($this->useAuth) {
            isys_auth_cmdb::instance()->is_allowed_to(isys_auth::VIEW, 'MODULE/C__MODULE__SHD_SMVIEW_CONNECT');
        }

        /** @var isys_component_database $db */
        $db = isys_application::instance()->container->get('database');
        $dao = isys_cmdb_dao_object::instance($db);

        $result = DaoUtil::allRows($dao->get_objects_by_type_id(C__OBJTYPE__APPLICATION, 2));

        return array_values(array_map(function($r) {
            return [
                'id' => $r['isys_obj__id'],
                'value' => $r['isys_obj__title'],
            ];
        }, $result));
    }
}
