<?php

use SHD\Smview\Connect\Domain\Azure\Exception\AzureCallFailedException;
use SHD\Smview\Connect\Service\Azure\Discovery\ResourceAnalyzer;
use Symfony\Contracts\HttpClient\Exception\TransportExceptionInterface;

/**
 * i-doit
 *
 * Azure API for SM-VIEW Connect.
 *
 * @package     i-doit
 * @subpackage  smview_connect
 * @author      Florian Weber <florian.weber@shd-online.de>
 * @copyright   2023 SHD System-Haus-Dresden GmbH
 * @license     http://www.i-doit.com/license
 */
class connect_api_model_azure extends isys_api_model_cmdb implements isys_api_model_interface
{
    public function read($p_params)
    {
        return [];
    }

    /**
     * @param $p_params
     * @return array
     * @throws Exception|TransportExceptionInterface
     */
    public function status($p_params)
    {
        if ($this->useAuth) {
            isys_auth_cmdb::instance()->is_allowed_to(isys_auth::VIEW, 'MODULE/C__MODULE__SHD_SMVIEW_CONNECT');
        }

        //$importer = isys_application::instance()->container->get('smview_connect.azure.resource_importer');

        return [
            //'online' => $importer->status($p_params['profile_id']),
            'online' => true,
        ];
    }

    /**
     * @param $p_params
     * @return array
     * @throws AzureCallFailedException
     * @throws isys_exception_dao
     */
    public function discovery($p_params)
    {
        if ($this->useAuth) {
            isys_auth_cmdb::instance()->is_allowed_to(isys_auth::VIEW, 'MODULE/C__MODULE__SHD_SMVIEW_CONNECT');
        }

        /** @var ResourceAnalyzer $ra */
        $ra = isys_application::instance()->container->get('smview_connect.azure.profile_'.$p_params['profile_id'].'.analyzer');

        $ra->discover();

        return [];
    }
}
