<?php

use SHD\Smview\Connect\DAO\DataMappingDAO;
use SHD\Smview\Connect\Service\DB\DaoUtil;

/**
 * i-doit
 *
 * Baramundi OS API for SM-VIEW Connect.
 *
 * @package     i-doit
 * @subpackage  smview_connect
 * @author      Florian Weber <florian.weber@shd-online.de>
 * @copyright   2023 SHD System-Haus-Dresden GmbH
 * @license     http://www.i-doit.com/license
 */
class connect_api_model_data_mapping extends isys_api_model_cmdb implements isys_api_model_interface
{
    /**
     * @param $p_params
     * @return array
     */
    public function read($p_params)
    {
        if ($this->useAuth) {
            isys_auth_cmdb::instance()->is_allowed_to(isys_auth::VIEW, 'MODULE/C__MODULE__SHD_SMVIEW_CONNECT');
        }

        $type = null;

        if(@isset($p_params['type'])) {
            $type = $p_params['type'];
        }

        $source = null;

        if(@isset($p_params['source'])) {
            $source = $p_params['source'];
        }

        return DaoUtil::allRows(
            DataMappingDAO::getInstance()->get_data($type, $source)
        ) ?? [];
    }

    /**
     * @param $p_params
     * @return array
     * @throws isys_exception_api
     */
    public function update($p_params)
    {
        if ($this->useAuth) {
            isys_auth_cmdb::instance()->is_allowed_to(isys_auth::VIEW, 'MODULE/C__MODULE__SHD_SMVIEW_CONNECT');
        }

        if (!isset($p_params['data'])) {
            throw new isys_exception_api('Please specify object data by setting \'data\' parameter.');
        }

        $data = $p_params['data'];

        DataMappingDAO::getInstance()->updateMappings($data['data_mapping']);

        return [
            'message' => 'Updated Data Mapping',
            'success' => true,
        ];
    }
}
