<?php

use SHD\Smview\Connect\Service\Telekom\ContractImporter;
use Webmozart\Assert\Assert;

class connect_api_model_debug_telekom extends isys_api_model_cmdb implements isys_api_model_interface
{
    /**
     * @throws \Symfony\Contracts\HttpClient\Exception\TransportExceptionInterface
     * @throws \Symfony\Contracts\HttpClient\Exception\ServerExceptionInterface
     * @throws \Symfony\Contracts\HttpClient\Exception\RedirectionExceptionInterface
     * @throws isys_exception_database
     * @throws \Symfony\Contracts\HttpClient\Exception\ClientExceptionInterface
     */
    public function read($p_params)
    {
        $profileId = $p_params['profile_id'];
        Assert::notNull($profileId);

        /** @var ContractImporter $importer */
        $importer = isys_application::instance()->container->get('smview_connect.telekom.contract_importer');

        return $importer->fetchContractsList($profileId);
    }

    public function raw($p_params)
    {
        $profileId = $p_params['profile_id'];
        Assert::notNull($profileId);
        $url = $p_params['url'];
        Assert::notNull($url);
        $method = $p_params['method'];
        Assert::notNull($method);

        $headers = $p_params['headers'] ?? [];

        /** @var ContractImporter $importer */
        $importer = isys_application::instance()->container->get('smview_connect.telekom.contract_importer');

        return $importer->exec($profileId, $method, $url, $headers);
    }
}
