<?php

use SHD\Smview\Connect\Service\Ldap\Importer;
use Webmozart\Assert\Assert;

class connect_api_model_ldap extends isys_api_model_cmdb implements isys_api_model_interface, shd_api_model_cmdb_runnable_interface
{
    public function read($p_params): array
    {
        return [];
    }

    public function run(array $params): array
    {
        $profileId = $params['profile_id'];
        Assert::notNull($profileId);

        /** @var Importer $importer */
        $importer = isys_application::instance()->container->get('smview_connect.ldap.profile_' . $params['profile_id'] . '.importer');

        return [
            'data' => $importer->import(),
            'message' => 'ldap import erfolgreich',
        ];
    }

    public function dryrun(array $params): array
    {
        return [];
    }

    /**
     * @param $p_params
     * @return array
     * @throws Exception
     */
    public function status($p_params): array
    {
        if ($this->useAuth) {
            isys_auth_cmdb::instance()->is_allowed_to(isys_auth::VIEW, 'MODULE/C__MODULE__SHD_SMVIEW_CONNECT');
        }

        try {
            /** @var Importer $importer */
            $importer = isys_application::instance()->container->get('smview_connect.ldap.profile_' . $p_params['profile_id'] . '.importer');

            return [
                'online' => $importer->status($p_params['profile_id']),
            ];
        } catch (Throwable $t) {
            /** @var \SHD\Smview\Connect\Service\ConnectLogger $logger */
            $logger = isys_application::instance()->container->get('smview_connect.logger');
            $logger->log($t->getMessage(), 'Ldap Status', \Monolog\Logger::ERROR);

            return [
                'online' => false,
            ];
        }
    }
}
