<?php

use SHD\Smview\Connect\DAO\ProfileDAO;
use SHD\Smview\Connect\Service\ConnectLogger;
use SHD\Smview\Connect\Service\AbstractConfiguration;
use SHD\Smview\Connect\Service\DB\DaoUtil;

class connect_api_model_profile_attributes extends isys_api_model_cmdb implements isys_api_model_interface
{
    /**
     * @param $p_params
     * @return array
     * @throws isys_exception_database
     */
    public function read($p_params): array
    {
        if ($this->useAuth) {
            isys_auth_cmdb::instance()->is_allowed_to(isys_auth::VIEW, 'MODULE/C__MODULE__SHD_SMVIEW_CONNECT');
        }

        $id = $p_params['id'] ?? null;

        if(!$id) {
            throw new Exception('profile id must not be null');
        }

        $profile = DaoUtil::allRows(ProfileDAO::getInstance()->get_data($id))[0] ?? null;

        if(!$profile) {
            throw new Exception('profile not found');
        }

        /** @var ConnectLogger $logger */
        $logger = isys_application::instance()->container->get('smview_connect.logger');

        try {
            if (!isys_application::instance()->container->has('smview_connect.profile_'.$id.'.config')) {
                throw new Exception('config not found');
            }

            /** @var AbstractConfiguration $config */
            $config = isys_application::instance()->container->get('smview_connect.profile_'.$id.'.config');

            return $config->getAttributes($id, true);
        } catch (Exception $exception) {
            $logger->log($exception->getMessage(), 'connect_api_model_profile_attributes', \Monolog\Logger::ERROR);
            return [];
        }
    }

    /**
     * @param $params
     * @return array
     * @throws isys_exception_database
     */
    public function attributes($params): array
    {
        return $this->read($params);
    }
}
