<?php

use SHD\Smview\Connect\Service\AbstractConfiguration;

/**
 * i-doit
 *
 * Profile Fields API for SM-VIEW Connect.
 *
 * @package     i-doit
 * @subpackage  smview_connect
 * @author      Florian Weber <florian.weber@shd-online.de>
 * @copyright   2023 SHD System-Haus-Dresden GmbH
 * @license     http://www.i-doit.com/license
 */
class connect_api_model_profile_fields extends isys_api_model_cmdb implements isys_api_model_interface
{
    /**
     * Get profile fields.
     *
     * @param array $p_params
     *
     * @return array
     * @throws Exception
     */
    public function read($p_params): array
    {
        if ($this->useAuth) {
            isys_auth_cmdb::instance()->is_allowed_to(isys_auth::VIEW, 'MODULE/C__MODULE__SHD_SMVIEW_CONNECT');
        }

        $profile_id = $p_params['profile_id'] ?? null;

        if(!$profile_id) {
            return [];
        }

        try {
            /** @var AbstractConfiguration $config */
            $config = @isys_application::instance()->container->get('smview_connect.profile_'.$profile_id.'.config') ?? null;
        } catch (Error|Exception $error) {
            return [];
        }

        if(!$config) {
            return [];
        }

        return $config->getAttributes($profile_id);
    }
}
