<?php

use SHD\Smview\Connect\Service\ImporterInterface;
use SHD\Smview\Connect\Service\Telekom\ContractImporter;
use SHD\Smview\Connect\Service\ThreadHandlerInterface;
use SHD\Smview\Connect\Service\Threading\ThreadDispatch;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class connect_api_model_threading extends isys_api_model_cmdb implements isys_api_model_interface
{
    public function read($p_params): array
    {
        $dir = ThreadDispatch::getProcDir();
        $procs = array_filter((array) glob($dir.'/*'));

        $p = [];

        foreach ($procs as $pid) {
            $status = file_get_contents($pid);
            $p[] = [
                'pid' => basename($pid),
                'status' => $status,
            ];
        }

        return $p;
    }

    /**
     * @throws isys_exception_database
     * @throws isys_exception_general
     */
    public function work($p_params): array
    {
        $pid = $p_params['pid'];
        $type = $p_params['type'];
        $data = $p_params['data'];
        $profileId = $p_params['profile_id'];

        switch ($type) {
            case ThreadDispatch::TELEKOM__FETCH_CONTRACT_DETAILS:
                /** @var ContractImporter $importer */
                $importer = isys_application::instance()->container->get('smview_connect.telekom.contract_importer');
                $importer->setConfigFromProfile($profileId);
                $importer->handleThread($pid, $type, $data);
                break;
            default:
                throw new isys_exception_general(sprintf('type %s not recognised', $type));
        }

        return [];
    }
}
