export interface Profile {
    id: number,
    title: string,
    creation_date: number,
    min_matching_field_count: number,
    add_new_objects: boolean,
    add_new_references: boolean,
    object_type_mappings: ObjectTypeMapping[],
    settings: ProfileSetting[],
    active: boolean,
    discovered_types: ProfileDiscoveryData[],
}

export interface ObjectTypeMapping {
    property_key: string,
    object_type_id: number
}

export interface ObjectTypeMappingKey {
    property_key: string,
    label?: string
}

export interface ProfileSetting {
    key: string,
    value: string,
}

export interface ProfileSettingKey {
    key: string,
    label: string,
    typeName: string,
    visible: boolean,
    value: any,
}

export interface ProfileDiscoveryData {
    type: string,
    key: string,
    value: string,
}
