import {Profile} from "../../Profile";
import * as React from "react";

interface DiscoveryStartActionProps {
    language: {[key: string]: string},
    image_url: string,
    is_editable: boolean,
    is_loading: boolean,
    active_profile: Profile,
    spinner: object,
    action: Function,
}

interface DiscoveryStartActionState {
}

export class DiscoveryStartAction extends React.Component<DiscoveryStartActionProps, DiscoveryStartActionState> {
    constructor(props: DiscoveryStartActionProps) {
        super(props)

        this.state = {
        }

        this.onAction = this.onAction.bind(this)
    }

    onAction() {
        this.props.action()
    }

    render() {
        return <button type="button"
                       className="btn btn-small"
                       disabled={!this.props.is_editable || this.props.is_loading}
                       onClick={this.onAction}>
            {this.props.language.LC__CMDB__SMVIEW_CONNECT__START_DISCOVERY}
            {this.props.spinner}
        </button>
    }
}
