import * as React from 'react'
import {DataMappingTableContainer} from "../components/DataMappingTableContainer";
import {DataMappingConfigItem, DataMappingItem} from "../MappingEditorCompose";
import {Profile} from "../../Profile";
const ReactTestRenderer = require('react-test-renderer');

let lang = {}

let profile: Profile = {
    id: 1,
    title: 'Profile 01',
    creation_date: null,
    min_matching_field_count: 1,
    add_new_objects: false,
    add_new_references: false,
    object_type_mappings: [],
    settings: [],
    active: true,
    discovered_types: [],
}

let config: DataMappingConfigItem[] = [
    {
        type: 'os',
        content_base: '',
        api_base: '',
        label: 'OS',
    },
]

let mapping: DataMappingItem[] = [
    {
        type: 'os',
        source: 'foo',
        target: 'bar',
    }
]

it('renders read-only data mapping table correctly', () => {
    const component = ReactTestRenderer.create(
        <DataMappingTableContainer data_mapping_config={config}
                          data_mapping={mapping}
                          data_items={[]}
                          source_data_items={[]}
                          is_loading={false}
                          active_profile={profile}
                          is_editable={false}
                          image_url={'img/icons/'}
                          language={lang}
                          onEditMapping={null} getCustomIdentifier={function (c) {}}/>
    )
    expect(component).toMatchSnapshot()
})
