import * as React from "react";

export interface ActionBarProps {
    disabled: boolean,
    handleAdd: Function,
    handleSave: Function,
    language: {[key: string]: string},
    image_url: string,
}

export interface ActionBarState {
}

export class ActionBar extends React.Component<ActionBarProps, ActionBarState> {
    constructor (props: ActionBarProps) {
        super(props)

        this.state = {
        }

        this.onAdd = this.onAdd.bind(this)
        this.onSave = this.onSave.bind(this)
    }

    onAdd() {
        this.props.handleAdd();
    }

    onSave() {
        this.props.handleSave();
    }

    render() {
        return <div>
            <button className="btn ml10" type="button" onClick={this.onSave} disabled={this.props.disabled}>
                <img src={this.props.image_url + "accept.png"} className="mr5" alt=""/>
                {this.props.language.LC__UNIVERSAL__BUTTON_SAVE}
            </button>
            <button className="btn ml10" type="button" onClick={this.onAdd} disabled={this.props.disabled}>
                <img src={this.props.image_url + "add.png"} className="mr5" alt=""/>
                {this.props.language.LC__UNIVERSAL__ADD}
            </button>
        </div>
    }
}
