<?php

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class isys_smview_connect_cmdb_dao_g_baramundi_metadata extends isys_cmdb_dao_category_global
{
    /**
     * Category's name. Will be used for the identifier, constant, main table, and many more.
     *
     * @var  string
     */
    protected $m_category = 'smview_connect_baramundi_metadata';

    /**
     * This variable holds the language constant of the current category.
     *
     * @var string
     */
    protected $categoryTitle = 'LC__CMDB__CATG__SMVIEW_CONNECT__BARAMUNDI_METADATA_TITLE';

    /**
     * @var string
     */
    protected $m_category_const = 'C__CATG__SMVIEW_CONNECT_BARAMUNDI_METATDATA';

    /**
     * Category entry is purgable
     *
     * @var bool
     */
    protected $m_is_purgable = false;

    /**
     * Is category multi-valued or single-valued?
     *
     * @var  boolean
     */
    protected $m_multivalued = false;

    /**
     * @return array
     */
    protected function properties(): array
    {
        $fieldEndpointId = new \idoit\Component\Property\Type\TextProperty(
            'C__CATG__SMVIEW_CONNECT_BARAMUNDI_METATDATA__ENDPOINT_ID',
            'LC__CMDB__CATG__SMVIEW_CONNECT__BARAMUNDI_METADATA_ENDPOINT_ID',
            'isys_catg_smview_connect_baramundi_metadata_list__endpoint_id',
            'isys_catg_smview_connect_baramundi_metadata_list'
        );
        $fieldEndpointId->getData()->setReadOnly(true);

        $fieldOrgunitId = new \idoit\Component\Property\Type\TextProperty(
            'C__CATG__SMVIEW_CONNECT_BARAMUNDI_METATDATA__ORGUNIT_ID',
            'LC__CMDB__CATG__SMVIEW_CONNECT__BARAMUNDI_METADATA_ORGUNIT_ID',
            'isys_catg_smview_connect_baramundi_metadata_list__orgunit_id',
            'isys_catg_smview_connect_baramundi_metadata_list'
        );
        $fieldOrgunitId->getData()->setReadOnly(true);

        return [
            'endpoint_id' => $fieldEndpointId,
            'orgunit_id'  => $fieldOrgunitId,
            'parent_id'  => array_replace_recursive(isys_cmdb_dao_category_pattern::text(), [
                C__PROPERTY__INFO => [
                    C__PROPERTY__INFO__TITLE       => 'LC__CMDB__CATG__SMVIEW_CONNECT__BARAMUNDI_METADATA_PARENT_ID',
                    C__PROPERTY__INFO__DESCRIPTION => 'Parent Orgunit ID'
                ],
                C__PROPERTY__DATA => [
                    C__PROPERTY__DATA__FIELD => 'isys_catg_smview_connect_baramundi_metadata_list__parent_id',
                    C__PROPERTY__DATA__READONLY => true,
                ],
                C__PROPERTY__UI   => [
                    C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CONNECT_BARAMUNDI_METATDATA__PARENT_ID'
                ]
            ]),
            'orgunit_name'  => array_replace_recursive(isys_cmdb_dao_category_pattern::text(), [
                C__PROPERTY__INFO => [
                    C__PROPERTY__INFO__TITLE       => 'LC__CMDB__CATG__SMVIEW_CONNECT__BARAMUNDI_METADATA_ORGUNIT_NAME',
                    C__PROPERTY__INFO__DESCRIPTION => 'Orgunit Title'
                ],
                C__PROPERTY__DATA => [
                    C__PROPERTY__DATA__FIELD => 'isys_catg_smview_connect_baramundi_metadata_list__orgunit_name',
                    C__PROPERTY__DATA__READONLY => true,
                ],
                C__PROPERTY__UI   => [
                    C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CONNECT_BARAMUNDI_METATDATA__ORGUNIT_NAME'
                ]
            ]),
            'hierarchy_path'  => array_replace_recursive(isys_cmdb_dao_category_pattern::text(), [
                C__PROPERTY__INFO => [
                    C__PROPERTY__INFO__TITLE       => 'LC__CMDB__CATG__SMVIEW_CONNECT__BARAMUNDI_METADATA_HIERARCHY_PATH',
                    C__PROPERTY__INFO__DESCRIPTION => 'Hierarchy Path'
                ],
                C__PROPERTY__DATA => [
                    C__PROPERTY__DATA__FIELD => 'isys_catg_smview_connect_baramundi_metadata_list__hierarchy_path',
                    C__PROPERTY__DATA__READONLY => true,
                ],
                C__PROPERTY__UI   => [
                    C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CONNECT_BARAMUNDI_METATDATA__HIERARCHY_PATH'
                ]
            ]),
            'primary_mac'  => array_replace_recursive(isys_cmdb_dao_category_pattern::text(), [
                C__PROPERTY__INFO => [
                    C__PROPERTY__INFO__TITLE       => 'LC__CMDB__CATG__SMVIEW_CONNECT__BARAMUNDI_METADATA_PRIMARY_MAC',
                    C__PROPERTY__INFO__DESCRIPTION => 'Primary Mac Adress'
                ],
                C__PROPERTY__DATA => [
                    C__PROPERTY__DATA__FIELD => 'isys_catg_smview_connect_baramundi_metadata_list__primary_mac',
                    C__PROPERTY__DATA__READONLY => true,
                ],
                C__PROPERTY__UI   => [
                    C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CONNECT_BARAMUNDI_METATDATA__PRIMARY_MAC'
                ]
            ]),
            'subnet_mask'  => array_replace_recursive(isys_cmdb_dao_category_pattern::text(), [
                C__PROPERTY__INFO => [
                    C__PROPERTY__INFO__TITLE       => 'LC__CMDB__CATG__SMVIEW_CONNECT__BARAMUNDI_METADATA_SUBNET_MASK',
                    C__PROPERTY__INFO__DESCRIPTION => 'Primary Subnet Mask'
                ],
                C__PROPERTY__DATA => [
                    C__PROPERTY__DATA__FIELD => 'isys_catg_smview_connect_baramundi_metadata_list__subnet_mask',
                    C__PROPERTY__DATA__READONLY => true,
                ],
                C__PROPERTY__UI   => [
                    C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CONNECT_BARAMUNDI_METATDATA__SUBNET_MASK'
                ]
            ]),
            'primary_user'  => array_replace_recursive(isys_cmdb_dao_category_pattern::text(), [
                C__PROPERTY__INFO => [
                    C__PROPERTY__INFO__TITLE       => 'LC__CMDB__CATG__SMVIEW_CONNECT__BARAMUNDI_METADATA_PRIMARY_USER',
                    C__PROPERTY__INFO__DESCRIPTION => 'Primary User'
                ],
                C__PROPERTY__DATA => [
                    C__PROPERTY__DATA__FIELD => 'isys_catg_smview_connect_baramundi_metadata_list__primary_user',
                    C__PROPERTY__DATA__READONLY => true,
                ],
                C__PROPERTY__UI   => [
                    C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CONNECT_BARAMUNDI_METATDATA__PRIMARY_USER'
                ]
            ]),
            'last_change'  => array_replace_recursive(isys_cmdb_dao_category_pattern::datetime(), [
                C__PROPERTY__INFO => [
                    C__PROPERTY__INFO__TITLE       => 'LC__CMDB__CATG__SMVIEW_CONNECT__BARAMUNDI_METADATA_LAST_CHANGE',
                    C__PROPERTY__INFO__DESCRIPTION => 'Last Change'
                ],
                C__PROPERTY__DATA => [
                    C__PROPERTY__DATA__FIELD => 'isys_catg_smview_connect_baramundi_metadata_list__last_change',
                    C__PROPERTY__DATA__READONLY => true,
                ],
                C__PROPERTY__UI   => [
                    C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CONNECT_BARAMUNDI_METATDATA__LAST_CHANGE'
                ]
            ]),
            'last_seen'  => array_replace_recursive(isys_cmdb_dao_category_pattern::datetime(), [
                C__PROPERTY__INFO => [
                    C__PROPERTY__INFO__TITLE       => 'LC__CMDB__CATG__SMVIEW_CONNECT__BARAMUNDI_METADATA_LAST_SEEN',
                    C__PROPERTY__INFO__DESCRIPTION => 'Last Seen'
                ],
                C__PROPERTY__DATA => [
                    C__PROPERTY__DATA__FIELD => 'isys_catg_smview_connect_baramundi_metadata_list__last_seen',
                    C__PROPERTY__DATA__READONLY => true,
                ],
                C__PROPERTY__UI   => [
                    C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CONNECT_BARAMUNDI_METATDATA__LAST_SEEN'
                ]
            ]),
            'last_user'  => array_replace_recursive(isys_cmdb_dao_category_pattern::text(), [
                C__PROPERTY__INFO => [
                    C__PROPERTY__INFO__TITLE       => 'LC__CMDB__CATG__SMVIEW_CONNECT__BARAMUNDI_METADATA_LAST_USER',
                    C__PROPERTY__INFO__DESCRIPTION => 'Last User'
                ],
                C__PROPERTY__DATA => [
                    C__PROPERTY__DATA__FIELD => 'isys_catg_smview_connect_baramundi_metadata_list__last_user',
                    C__PROPERTY__DATA__READONLY => true,
                ],
                C__PROPERTY__UI   => [
                    C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CONNECT_BARAMUNDI_METATDATA__LAST_USER'
                ]
            ]),
            'architecture'  => array_replace_recursive(isys_cmdb_dao_category_pattern::text(), [
                C__PROPERTY__INFO => [
                    C__PROPERTY__INFO__TITLE       => 'LC__CMDB__CATG__SMVIEW_CONNECT__BARAMUNDI_METADATA_ARCHITECTURE',
                    C__PROPERTY__INFO__DESCRIPTION => 'Architecture'
                ],
                C__PROPERTY__DATA => [
                    C__PROPERTY__DATA__FIELD => 'isys_catg_smview_connect_baramundi_metadata_list__architecture',
                    C__PROPERTY__DATA__READONLY => true,
                ],
                C__PROPERTY__UI   => [
                    C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CONNECT_BARAMUNDI_METATDATA__ARCHITECTURE'
                ]
            ]),
        ];
    }
}
