<?php

use idoit\Component\Property\Type\TextAreaProperty;
use idoit\Component\Property\Type\TextProperty;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class isys_smview_connect_cmdb_dao_g_telekom_contr_meta extends isys_cmdb_dao_category_global
{
    /**
     * Category's name. Will be used for the identifier, constant, main table, and many more.
     *
     * @var  string
     */
    protected $m_category = 'smview_connect_telekom_contr_meta';

    /**
     * This variable holds the language constant of the current category.
     *
     * @var string
     */
    protected $categoryTitle = 'LC__CMDB__CATG__SMVIEW_CONNECT__TELEKOM_CONTRACT_METADATA_TITLE';

    /**
     * @var string
     */
    protected $m_category_const = 'C__CATG__SMVIEW_CONNECT_TELEKOM_CONTRACT_METATDATA';

    /**
     * Category entry is purgable
     *
     * @var bool
     */
    protected $m_is_purgable = false;

    /**
     * Is category multi-valued or single-valued?
     *
     * @var  boolean
     */
    protected $m_multivalued = false;

    public $table = 'isys_catg_smview_connect_telekom_contr_meta_list';

    protected function properties(): array
    {
        $fieldContractId = new TextProperty(
            'C__CATG__SMVIEW_CONNECT_TELEKOM_CONTRACT_METATDATA__CONTRACT_ID',
            'LC__CMDB__CATG__SMVIEW_CONNECT__TELEKOM_CONTRACT_METATDATA_CONTRACT_ID',
            'isys_catg_smview_connect_telekom_contr_meta_list__contract_id',
            'isys_catg_smview_connect_telekom_contr_meta_list'
        );
        $fieldContractId->getData()->setReadOnly(true);

        $fieldTariffOptions = new TextAreaProperty(
            'C__CATG__SMVIEW_CONNECT_TELEKOM_CONTRACT_METATDATA__TARIFF_OPTIONS',
            'LC__CMDB__CATG__SMVIEW_CONNECT__TELEKOM_CONTRACT_METATDATA_TARIFF_OPTIONS',
            'isys_catg_smview_connect_telekom_contr_meta_list__tariff_options',
            'isys_catg_smview_connect_telekom_contr_meta_list'
        );
        $fieldTariffOptions->getData()->setReadOnly(true);

        return [
            'contract_id' => $fieldContractId,
            'tariff_options' => $fieldTariffOptions,
            'last_seen' => array_replace_recursive(isys_cmdb_dao_category_pattern::datetime(), [
                C__PROPERTY__INFO => [
                    C__PROPERTY__INFO__TITLE       => 'LC__CMDB__CATG__SMVIEW_CONNECT__TELEKOM_CONTRACT_METATDATA_LAST_SEEN',
                    C__PROPERTY__INFO__DESCRIPTION => 'Last Seen'
                ],
                C__PROPERTY__DATA => [
                    C__PROPERTY__DATA__FIELD => 'isys_catg_smview_connect_telekom_contr_meta_list__last_seen',
                    C__PROPERTY__DATA__READONLY => true,
                ],
                C__PROPERTY__UI   => [
                    C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CONNECT_TELEKOM_CONTRACT_METATDATA__LAST_SEEN'
                ]
            ]),
        ];
    }
}
