<?php

use idoit\Component\Property\Type\TextProperty;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class isys_smview_connect_cmdb_dao_g_telekom_frame_meta extends isys_cmdb_dao_category_global
{
    /**
     * Category's name. Will be used for the identifier, constant, main table, and many more.
     *
     * @var  string
     */
    protected $m_category = 'smview_connect_telekom_frame_meta';

    /**
     * This variable holds the language constant of the current category.
     *
     * @var string
     */
    protected $categoryTitle = 'LC__CMDB__CATG__SMVIEW_CONNECT__TELEKOM_FRAME_CONTRACT_METADATA_TITLE';

    /**
     * @var string
     */
    protected $m_category_const = 'C__CATG__SMVIEW_CONNECT_TELEKOM_FRAME_CONTRACT_METATDATA';

    /**
     * Category entry is purgable
     *
     * @var bool
     */
    protected $m_is_purgable = false;

    /**
     * Is category multi-valued or single-valued?
     *
     * @var  boolean
     */
    protected $m_multivalued = false;

    public $table = 'isys_catg_smview_connect_telekom_frame_meta_list';

    protected function properties(): array
    {
        $fieldAgreementId = new TextProperty(
            'C__CATG__SMVIEW_CONNECT_TELEKOM_FRAME_CONTRACT_METATDATA__AGREEMENT_ID',
            'LC__CMDB__CATG__SMVIEW_CONNECT__TELEKOM_FRAME_CONTRACT_METATDATA_AGREEMENT_ID',
            'isys_catg_smview_connect_telekom_frame_meta_list__agreement_id',
            'isys_catg_smview_connect_telekom_frame_meta_list'
        );
        $fieldAgreementId->getData()->setReadOnly(true);

        return [
            'agreement_id' => $fieldAgreementId,
        ];
    }
}
