<?php

use idoit\Component\Property\Type\DialogYesNoProperty;
use idoit\Component\Property\Type\TextProperty;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class isys_smview_connect_cmdb_dao_g_telekom_sim_meta extends isys_cmdb_dao_category_global
{
    /**
     * Category's name. Will be used for the identifier, constant, main table, and many more.
     *
     * @var  string
     */
    protected $m_category = 'smview_connect_telekom_sim_meta';

    /**
     * This variable holds the language constant of the current category.
     *
     * @var string
     */
    protected $categoryTitle = 'LC__CMDB__CATG__SMVIEW_CONNECT__TELEKOM_SIM_METADATA_TITLE';

    /**
     * @var string
     */
    protected $m_category_const = 'C__CATG__SMVIEW_CONNECT_TELEKOM_SIM_METATDATA';

    /**
     * Category entry is purgable
     *
     * @var bool
     */
    protected $m_is_purgable = false;

    /**
     * Is category multi-valued or single-valued?
     *
     * @var  boolean
     */
    protected $m_multivalued = false;

    public $table = 'isys_catg_smview_connect_telekom_sim_meta_list';

    protected function properties(): array
    {
        $fieldSimId = new TextProperty(
            'C__CATG__SMVIEW_CONNECT_TELEKOM_SIM_METATDATA__SIM_ID',
            'LC__CMDB__CATG__SMVIEW_CONNECT__TELEKOM_SIM_METATDATA_SIM_ID',
            'isys_catg_smview_connect_telekom_sim_meta_list__sim_id',
            'isys_catg_smview_connect_telekom_sim_meta_list'
        );
        $fieldSimId->getData()->setReadOnly(true);

//        $fieldCardType = new TextProperty(
//            'C__CATG__SMVIEW_CONNECT_TELEKOM_SIM_METATDATA__CARD_TYPE',
//            'LC__CMDB__CATG__SMVIEW_CONNECT__TELEKOM_SIM_METATDATA_CARD_TYPE',
//            'isys_catg_smview_connect_telekom_sim_meta_list__card_type',
//            'isys_catg_smview_connect_telekom_sim_meta_list'
//        );
//        $fieldCardType->getData()->setReadOnly(true);
//
//        $fieldEsim = new TextProperty(
//            'C__CATG__SMVIEW_CONNECT_TELEKOM_SIM_METATDATA__ESIM',
//            'LC__CMDB__CATG__SMVIEW_CONNECT__TELEKOM_SIM_METATDATA_ESIM',
//            'isys_catg_smview_connect_telekom_sim_meta_list__esim',
//            'isys_catg_smview_connect_telekom_sim_meta_list'
//        );
//        $fieldEsim->getData()->setReadOnly(true);
//
//        $fieldMode = new TextProperty(
//            'C__CATG__SMVIEW_CONNECT_TELEKOM_SIM_METATDATA__MODE',
//            'LC__CMDB__CATG__SMVIEW_CONNECT__TELEKOM_SIM_METATDATA_MODE',
//            'isys_catg_smview_connect_telekom_sim_meta_list__mode',
//            'isys_catg_smview_connect_telekom_sim_meta_list'
//        );
//        $fieldMode->getData()->setReadOnly(true);
//
//        $fieldRings = new DialogYesNoProperty(
//            'C__CATG__SMVIEW_CONNECT_TELEKOM_SIM_METATDATA__RINGS',
//            'LC__CMDB__CATG__SMVIEW_CONNECT__TELEKOM_SIM_METATDATA_RINGS',
//            'isys_catg_smview_connect_telekom_sim_meta_list__rings',
//            'isys_catg_smview_connect_telekom_sim_meta_list'
//        );
//        $fieldRings->getData()->setReadOnly(true);

        return [
            'sim_id' => $fieldSimId,
//            'card_type' => $fieldCardType,
//            'esim' => $fieldEsim,
//            'mode' => $fieldMode,
//            'rings' => $fieldRings,
            'last_seen' => array_replace_recursive(isys_cmdb_dao_category_pattern::datetime(), [
                C__PROPERTY__INFO => [
                    C__PROPERTY__INFO__TITLE       => 'LC__CMDB__CATG__SMVIEW_CONNECT__TELEKOM_SIM_METATDATA_LAST_SEEN',
                    C__PROPERTY__INFO__DESCRIPTION => 'Last Seen'
                ],
                C__PROPERTY__DATA => [
                    C__PROPERTY__DATA__FIELD => 'isys_catg_smview_connect_telekom_sim_meta_list__last_seen',
                    C__PROPERTY__DATA__READONLY => true,
                ],
                C__PROPERTY__UI   => [
                    C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CONNECT_TELEKOM_SIM_METATDATA__LAST_SEEN'
                ]
            ]),
        ];
    }
}
