<?php

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class isys_smview_connect_cmdb_dao_g_vsphere_vm_metadata extends isys_cmdb_dao_category_global
{
    /**
     * Category's name. Will be used for the identifier, constant, main table, and many more.
     *
     * @var  string
     */
    protected $m_category = 'smview_connect_vsphere_vm_metadata';

    /**
     * This variable holds the language constant of the current category.
     *
     * @var string
     */
    protected $categoryTitle = 'LC__CMDB__CATG__SMVIEW_CONNECT__VSPHERE_VM_METADATA_TITLE';

    /**
     * @var string
     */
    protected $m_category_const = 'C__CATG__SMVIEW_CONNECT_VSPHERE_VM_METATDATA';

    /**
     * Category entry is purgable
     *
     * @var bool
     */
    protected $m_is_purgable = false;

    /**
     * Is category multi-valued or single-valued?
     *
     * @var  boolean
     */
    protected $m_multivalued = false;

    public $table = 'isys_catg_smview_connect_vsphere_vm_metadata_list';

    /**
     * @return array
     */
    protected function properties(): array
    {
        $props = [];

        $props['vm_id'] = new \idoit\Component\Property\Type\TextProperty(
            'C__CATG__SMVIEW_CONNECT_VSPHERE_VM_METATDATA__VM_ID',
            'LC__CMDB__CATG__SMVIEW_CONNECT__VSPHERE_VM_METADATA_VM_ID',
            'isys_catg_smview_connect_vsphere_vm_metadata_list__vm_id',
            'isys_catg_smview_connect_vsphere_vm_metadata_list'
        );
        $props['vm_id']->getData()->setReadOnly(true);

        $props['name'] = new \idoit\Component\Property\Type\TextProperty(
            'C__CATG__SMVIEW_CONNECT_VSPHERE_VM_METATDATA__NAME',
            'LC__CMDB__CATG__SMVIEW_CONNECT__VSPHERE_VM_METADATA_NAME',
            'isys_catg_smview_connect_vsphere_vm_metadata_list__name',
            'isys_catg_smview_connect_vsphere_vm_metadata_list'
        );
        $props['name']->getData()->setReadOnly(true);

        $props['os'] = new \idoit\Component\Property\Type\TextProperty(
            'C__CATG__SMVIEW_CONNECT_VSPHERE_VM_METATDATA__OS',
            'LC__CMDB__CATG__SMVIEW_CONNECT__VSPHERE_VM_METADATA_OS',
            'isys_catg_smview_connect_vsphere_vm_metadata_list__os',
            'isys_catg_smview_connect_vsphere_vm_metadata_list'
        );
        $props['os']->getData()->setReadOnly(true);

        $props['os_family'] = new \idoit\Component\Property\Type\TextProperty(
            'C__CATG__SMVIEW_CONNECT_VSPHERE_VM_METATDATA__OS_FAMILY',
            'LC__CMDB__CATG__SMVIEW_CONNECT__VSPHERE_VM_METADATA_OS_FAMILY',
            'isys_catg_smview_connect_vsphere_vm_metadata_list__os_family',
            'isys_catg_smview_connect_vsphere_vm_metadata_list'
        );
        $props['os_family']->getData()->setReadOnly(true);

        return $props;
    }
}
