<?php

/**
 * i-doit
 *
 * DAO: list for assigned processes.
 *
 * @package    idoit
 * @subpackage smview_connect
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  2023 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license MIT
 */
class isys_cmdb_dao_list_catg_smview_connect_assigned_processes extends isys_cmdb_dao_list
{

    /**
     * Return constant of category.
     *
     * @return integer
     */
    public function get_category()
    {
        return defined_or_default('C__CATG__SMVIEW_CONNECT_ASSIGNED_PROCESSES');
    }

    /**
     * Return constant of category type.
     *
     * @return integer
     */
    public function get_category_type()
    {
        return C__CMDB__CATEGORY__TYPE_GLOBAL;
    }

    /**
     * Returns array with table headers.
     *
     * @return array
     */
    public function get_fields()
    {
        return [
            'isys_obj__id'    => 'LC__UNIVERSAL__OBJECT_ID',
            'isys_obj__title' => 'LC__SHD__PROCESS',
        ];
    }

    /**
     * Make a custom row link.
     *
     * @return string
     */
    public function make_row_link()
    {
        return isys_helper_link::get_base() . isys_helper_link::create_url([
            C__CMDB__GET__OBJECT => "[{isys_obj__id}]",
        ]);
    }
}
