<?php

use SHD\Smview\Connect\Service\DB\DaoUtil;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class isys_cmdb_dao_list_catg_smview_connect_azure_relation extends isys_component_dao_category_table_list
{
    public function __construct($p_db)
    {
        isys_component_template_navbar::getInstance()
            ->set_visible(false, C__NAVBAR_BUTTON__EDIT)
            ->set_visible(false, C__NAVBAR_BUTTON__SAVE)
            ->set_visible(false, C__NAVBAR_BUTTON__NEW)
        ;

        parent::__construct($p_db);
    }

    public function get_category()
    {
        return defined_or_default('C__CATG__SMVIEW_CONNECT_AZURE_RELATION');
    }

    public function modify_row(&$p_row)
    {
        $dao = isys_cmdb_dao_object::instance($this->get_database_component());
        $obj2 = DaoUtil::allRows($dao->get_object_by_id($p_row['isys_catg_smview_connect_azure_relation_list__isys_obj__rel_id']))[0] ?? null;

        $p_row['object_1_title'] = $p_row['isys_obj__title'];
        $p_row['object_2_title'] = $obj2['isys_obj__title'];
    }

    public function get_fields()
    {
        return [
            'isys_catg_smview_connect_azure_relation_list__id' => 'ID',
            'object_1_title' => 'Object 1',
            'object_2_title' => 'Object 2',
        ];
    }

    public function make_row_link($getParams = [])
    {
        $objectField = '[{' . $this->get_dao_category()->get_connected_object_id_field() . '}]';

        return isys_helper_link::create_url([
            C__CMDB__GET__OBJECT   => $objectField,
            C__CMDB__GET__VIEWMODE => C__CMDB__VIEW__CATEGORY,
            C__CMDB__GET__TREEMODE => C__CMDB__VIEW__TREE_OBJECT,
            C__CMDB__GET__CATG     => defined_or_default('C__CATG__GLOBAL'),
        ]);
    }
}
