<?php

/**
 * i-doit
 *
 * UI: Assigned processes category.
 *
 * @package    idoit
 * @subpackage smview_connect
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  2023 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license MIT
 */
class isys_cmdb_ui_category_g_smview_connect_assigned_processes extends isys_cmdb_ui_category_global
{

    /**
     * Processes the UI for the category check_mk
     *
     * @param  isys_cmdb_dao_category $p_cat The corresponding category DAO
     *
     * @throws isys_exception_cmdb
     * @throws isys_exception_general
     */
    public function process(isys_cmdb_dao_category $p_cat)
    {
        parent::process_list($p_cat);
    }

    /**
     * Fetches category's title from database.
     *
     * @param isys_cmdb_dao_category &$p_cat Category's DAO
     * @return string  Category's title, otherwise error message.
     * @throws Exception
     */
    public function gui_get_title(isys_cmdb_dao_category &$p_cat)
    {
        $lang = isys_application::instance()->container->get('language');
        return $lang->get('LC__CMDB__CATG__SMVIEW_CONNECT__ASSIGNED_PROCESSES_TITLE');
    }
}
