<?php

use SHD\Smview\Connect\Domain\Azure\idoit\AzureMetadataCategoryData;
use SHD\Smview\Connect\Service\DB\DaoUtil;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class isys_cmdb_ui_category_g_smview_connect_azure_metadata extends isys_cmdb_ui_category_global
{
    public function init(isys_cmdb_dao_category $p_cat)
    {
        parent::init($p_cat);

        $this->set_template(isys_module_shd_smview_connect::get_tpl_dir().'module/cmdb/azure_metadata.tpl');
    }

    public function process(isys_cmdb_dao_category $p_cat)
    {
        parent::process($p_cat);

        $this->deactivate_commentary();
        $this->disable_ajax_save();

        $props = array_filter($p_cat->get_properties(), function ($p) {
            if(method_exists($p, 'isVisible')) {
                return $p->isVisible();
            }

            return true;
        });

        $jsonProps = [
            AzureMetadataCategoryData::AZURE_DETAILS => $p_cat->get_properties()[AzureMetadataCategoryData::AZURE_DETAILS],
        ];

        $jsonValues = [];

        $resolver = function($key, $data) use (&$resolver, &$jsonValues) {
            foreach ($data as $k => $v) {
                if(is_array($v)) {
                    $resolver($key.'_'.$k, $v);

                    continue;
                }

                $name = str_replace('_', ' / ', $key.'_'.$k);

                $jsonValues[$key.'_'.$k] = ['name' => $name, 'data' => $v];
            }
        };

        /**
         * @var string $key
         * @var \SHD\Smview\Connect\Domain\idoit\Property\Type\JsonProperty $jsonProp
         */
        foreach ($jsonProps as $key => $jsonProp) {
            $data = json_decode(DaoUtil::allRows($p_cat->get_data_by_property(null, $p_cat->get_object_id(), $key))[0][$key] ?? null, true);

            $resolver($key, $data);
        }

        //todo: aus config holen
        $azurePortal = 'https://portal.azure.com';
        $tenantString = 'SHDOnline.onmicrosoft.com';
        $resourceId = DaoUtil::allRows($p_cat->get_data_by_property(null, $p_cat->get_object_id(), AzureMetadataCategoryData::AZURE_ID))[0][AzureMetadataCategoryData::AZURE_ID] ?? null;

        $azureLink = sprintf('%s/#@%s/resource%s', $azurePortal, $tenantString, $resourceId);

        $this->get_template_component()->assign('properties', $props);
        $this->get_template_component()->assign('dynamic_data', $jsonValues);
        $this->get_template_component()->assign('azure_link', $azureLink);
    }
}
