<?php

/**
 * i-doit
 *
 * Module initializer
 *
 * @package    idoit
 * @subpackage smview_connect
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  2022 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license MIT
 */

// include composer's autoloader
$vendorDir = dirname(__FILE__) . '/vendor/';
if (file_exists($vendorDir . 'autoload.php')) {
    include_once($vendorDir . 'autoload.php');
}
unset($vendorDir);

/* Initialize autoloader */
if (include_once 'isys_module_shd_smview_connect_autoload.class.php') {
    spl_autoload_register('isys_module_shd_smview_connect_autoload::init');
}

//load nun über composer autoloader
//Psr4AutoloaderClass::factory()->addNamespace('SHD\Smview\Connect', __DIR__ . '/src/');

/* Append custom module language file */
global $g_idoit_language_short;

$lang_path = __DIR__ . DS . 'lang' . DS . $g_idoit_language_short . '.inc.php';
if (file_exists($lang_path)) {
    $l_language = include_once $lang_path;

    if (is_array($l_language)) {
        global $g_comp_template_language_manager;
        $g_comp_template_language_manager->append_lang($l_language);
    }
}

//lizenzierung der adapter
if (isset($_SESSION['licensed_addons'])) {
    foreach ($_SESSION['licensed_addons'] as $identifier => $addon) {
        $moduleClassName = strtolower('isys_module_' . $identifier);
        if (class_exists($moduleClassName)) {
            if (is_a($moduleClassName, 'idoit\AddOn\LicensableInterface', true)) {
                /**
                 * @var $moduleClassName idoit\AddOn\LicensableInterface
                 */
                $moduleClassName::setLicensed($addon['licensed']);
            } else {
                /**
                 * @var $moduleClassName isys_module
                 */
                $moduleClassName::set_licenced($addon['licensed']);
            }
        }
    }
}
