<?php

use idoit\AddOn\LicensableInterface;
use SHD\Smview\Connect\Service\ShdLicense;

/**
 * License Stub Baseclass for Connect Adapter Licensing
 *
 * @author Florian Weber <florian.weber@shd-online.de>
 */
abstract class isys_module_shd_smview_connect_adapter extends isys_module implements LicensableInterface
{
    public static function isLicensed(): bool
    {
        if(self::isLicensedViaSHD()) {
            return true;
        }

        return self::isLicensedViaIdoit();
    }

    public static function setLicensed($isLicensed)
    {
        static::$isLicensed = $isLicensed;
    }

    public static function getModuleLicenseName(): string
    {
        return static::$moduleLicenseName;
    }

    public static function isLicensedViaIdoit(): bool
    {
        return static::$isLicensed;
    }

    public static function isLicensedViaSHD(): bool
    {
        $lic = new ShdLicense();

        return $lic->is_licensed(static::$moduleLicenseName);
    }
}
