# OpenPGP License Signature

## PHP OpenPgp
### Setup private key to generate licenses

The private key is needed to create licenses and is stored within PSR (Password-Safe).
PSR: https://shdpsr.shd-online.de/document/edit/93f4f95e-fc6d-ec11-91f9-005056b354b6

Download and place this key within this directory to use it.

### Generate Key

(Normally there is no need to create new keys.)

- $pgp = new ShdPgp();
- $pgp->generate_key();

### Sign message

- $pgp->sign($message);

### Validate message

- $pgp->verify($message);

## GnuPG
### Generate key

- gpg --default-new-key-algo rsa4096 --gen-key

### Clear-Sign File

- gpg --clearsign test.txt

### Export keys

- gpg --list-keys
- gpg --export -a "info@shd-online.de" > public.key
- gpg --list-secret-keys
- gpg --export-secret-keys "info@shd-online.de" > private.key

### Import keys

- gpg --import public.key
