<?php

/**
 * SHD SM-VIEW Connect Rest Wrapper
 * (c) 2023 SHD System-Haus-Dresden GmbH
 */

// Set error reporting.
error_reporting(E_ALL & ~E_NOTICE & ~E_DEPRECATED & ~E_STRICT & ~E_WARNING);

include_once __DIR__ . '/../vendor/autoload.php';

use idoit\Context\Context;

Context::instance()->setOrigin(Context::ORIGIN_API);

// Check if api is present
if (file_exists(__DIR__ . '/classes/modules/shd_smview_connect/rest.php')) {
    // Calculate idoit root directory
    $idoitRootDirectory = dirname(__DIR__);

    // Include api entry point file
    include_once __DIR__ . '/classes/modules/shd_smview_connect/rest.php';
} else {

    http_response_code(500);
    header('Content-Type: application/json; charset=utf-8');

    echo json_encode([
        'error' => 'rest api not accessible',
        'code' => 500,
    ]);

    die;
}
