<?php

namespace idoit\Module\shd_smview_connect\Console\Command;

use idoit\Console\Command\AbstractCommand;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Helper\Table;
use Symfony\Component\Console\Input\InputDefinition;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

class ListImportersCommand extends AbstractCommand
{
    protected static $defaultName = 'connect:list:importers';

    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $importers = ImportAllCommand::getImporters();

        $table = new Table($output);
        $table->setHeaders(['Importer', 'Profile ID']);
        $rows = [];

        foreach ($importers as $importer) {
            $rows[] = [$importer->getName(), $importer->getProfileId()];
        }

        $table->setRows($rows);
        $table->render();

        return Command::SUCCESS;
    }

    public function getCommandName(): string
    {
        return self::$defaultName;
    }

    public function getCommandDescription(): string
    {
        return 'List all importers';
    }

    public function getCommandDefinition(): InputDefinition
    {
        return new InputDefinition();
    }

    public function isConfigurable(): bool
    {
        return false;
    }

    public function getCommandUsages(): array
    {
        return [];
    }
}
