<?php

namespace SHD\Smview\Connect\Domain\Azure;

use SHD\Smview\Connect\Domain\idoit\TransferObjectInterface;
use stdClass;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class AzureResource implements TransferObjectInterface
{
    /**
     * @var string
     */
    public string $id;

    /**
     * @var string
     */
    public string $name;

    /**
     * @var AzureResourceTypeInterface
     */
    public AzureResourceTypeInterface $type;

    /**
     * @var string
     */
    public string $location;

    /**
     * @var array<int>|null
     */
    public ?array $zones;

    /**
     * @var string|null
     */
    public ?string $managedBy;

    /**
     * @var stdClass
     */
    public stdClass $rawProperties;

    /**
     * @var array<AzureResource>
     */
    public array $networkInterfaces;

    /**
     * @var array<AzureResource>
     */
    public array $ipAddresses;

    /**
     * @var array<AzureResource>
     */
    public array $disks;
}
