<?php

namespace SHD\Smview\Connect\Domain\Azure;

use SHD\Smview\Connect\Domain\Azure\Provider\ProviderDefinitionInterface;
use SHD\Smview\Connect\Domain\Azure\Provider\ResourceDetailProviderDefinition;
use SHD\Smview\Connect\Domain\idoit\IdoitCategoryDataInterface;
use SHD\Smview\Connect\Domain\idoit\IdoitCategoryDataProviderInterface;
use SHD\Smview\Connect\Domain\idoit\TransferObjectInterface;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class GenericResourceType implements AzureResourceTypeInterface, IdoitCategoryDataProviderInterface
{
    protected string $name;

    public function __construct(string $name)
    {
        $this->name = $name;
    }

    /**
     * @return string
     */
    public function getName(): string
    {
        return $this->name;
    }

    /**
     * @return array<string>
     */
    public function getParentTypes(): array
    {
        return [];
    }

    /**
     * Defines if the type is being used to import resources from azure
     *
     * @return bool
     */
    public function useForImport(): bool
    {
        return true;
    }

    public function getProviderDefinition(): ProviderDefinitionInterface
    {
        return new ResourceDetailProviderDefinition();
    }

    /**
     * @param string $class
     * @param AzureResource $object
     * @return array<IdoitCategoryDataInterface>|null
     */
    public function getCategoryDataDefintition(string $class, TransferObjectInterface $object): ?array
    {
        return null;
    }
}
