const providers = require('./providers.json');
const fs = require('fs')

let p = providers.value.map((provider) => {
    let data = {}
    let ns = provider.namespace
    let rt = provider.resourceTypes

    let types = rt.map((type) => {
        let apiVersions = type.apiVersions.filter((v) => {
            return !v.includes('preview') && !v.includes('alpha') && !v.includes('beta')
        })

        return {
            namespace: ns + '/' + type.resourceType,
            versions: apiVersions
        }
    })

    data.namespace = ns
    data.types = types

    return data
})

let data = []

p.forEach((d) => {
    d.types.forEach((t) => {
        data.push({
            namespace: t.namespace,
            version: t.versions[0]
        })
    })
})

$php = '<?php\n'
$php += '\n'
$php += '/*\n'
$php += ' * auto generated from the azure api https://management.azure.com/providers?api-version=2022-12-01\n'
$php += ' */\n'
$php += 'return [\n'

data.forEach((d) => {
    if(d.version == undefined) {
        return
    }

    $php += '\t\'' + d.namespace + '\' => \'' + d.version + '\',\n'
})

$php += '];\n'

fs.writeFileSync('./providers.php', $php)