<?php

namespace SHD\Smview\Connect\Domain\Azure\idoit;

use Exception;
use SHD\Smview\Connect\Domain\idoit\IdoitCategoryData;
use SHD\Smview\Connect\Domain\idoit\IdoitCategoryDataInterface;
use SHD\Smview\Connect\Domain\idoit\IdoitObject;
use SHD\Smview\Connect\Service\DB\DaoUtil;
use isys_exception_dao;
use isys_exception_database;
use isys_smview_connect_cmdb_dao_g_azure_relation;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class AzureRelationCategoryData extends IdoitCategoryData
{
    public const OBJECT_ID_REL = 'id2';
    public const SYS_ID_REL = 'sys_id2';

    /**
     * @param IdoitObject $item
     * @return IdoitCategoryDataInterface
     * @throws isys_exception_dao
     * @throws isys_exception_database
     * @throws Exception
     */
    public function syncDataTo(IdoitObject $item): IdoitCategoryDataInterface
    {
        $dao = isys_smview_connect_cmdb_dao_g_azure_relation::instance($this->getDatabase());

        if(isset($this->data[self::SYS_ID_REL])) {
            $this->data[self::OBJECT_ID_REL] = $dao->get_obj_id_by_sysid($this->data[self::SYS_ID_REL]);
        }

        //wenn rel objekt nicht existiert abbrechen
        if((DaoUtil::allRows($dao->get_object_by_id($this->data[self::OBJECT_ID_REL]))[0] ?? null) == null) {
            return $this;
        }

        $dao->relateObjects($item->getId(), $this->data[self::OBJECT_ID_REL]);

        return $this;
    }
}
