<?php

namespace SHD\Smview\Connect\Domain\Baramundi;

use DateTime;
use SHD\Smview\Connect\Domain\idoit\TransferObjectInterface;

/**
 * Baramundi Endpoint Model
 *
 * @package    i-doit
 * @subpackage smview_connect
 * @author     Florian Weber <florian.weber@shd-online.de>
 * @copyright  2023 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class Endpoint implements TransferObjectInterface
{
    /**
     * @var string
     */
    public $id;

    /**
     * @var int
     */
    public $type;

    /**
     * @var string|null
     */
    public $displayName;

    /**
     * @var string|null
     */
    public $hostName;

    /**
     * @var string|null
     */
    public $domain;

    /**
     * @var string|null
     */
    public $primaryMac;

    /**
     * @var string|null
     */
    public $primaryIp;

    /**
     * @var string|null
     */
    public $primarySubnetMask;

    /**
     * @var string|null
     */
    public $primaryUser;

    /**
     * @var DateTime|null
     */
    public $lastChange;

    /**
     * @var DateTime|null
     */
    public $lastSeen;

    /**
     * @var string|null
     */
    public $lastUser;

    /**
     * @var string|null
     */
    public $architecture;

    /**
     * @var ModelInfo|null
     */
    public $model;

    /**
     * @var OperatingSystemInfo|null
     */
    public $operatingSystem;

    /**
     * @var CpuInfo|null
     */
    public $cpu;

    /**
     * @var MemoryInfo|null
     */
    public $memory;

    /**
     * @var OrgUnit|null
     */
    public $orgUnit;

    /**
     * @var Application[]
     */
    public $applications = [];
}
