<?php

namespace SHD\Smview\Connect\Domain\Telekom;

use DateTime;

/**
 * Telekom Contract Model
 *
 * @package    i-doit
 * @subpackage smview_connect
 * @author     Florian Weber <florian.weber@shd-online.de>
 * @copyright  2022 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
final class Contract extends Product
{
    /**
     * @var string
     */
    public $status;

    /**
     * @var DateTime
     */
    public $terminationDate;

    /**
     * @var string
     */
    public $agreementId;

    /**
     * @var array<MSISDNData>
     */
    public $msisdn;

    /**
     * @var array<SimCard>
     */
    public $relatedSimCard = [];

    /**
     * @var array<ProductTermData>
     */
    public $productTerm;

    /**
     * @var RelatedParty
     */
    public $relatedParty;

    /**
     * @var string|null
     */
    public $customerCostCenter;

    /**
     * @var string|null
     */
    public $customerCostCenterUser;

    public string $rawJson;

    /**
     * @param int $id
     * @param string $type
     * @param string $description
     * @param DateTime $startDate
     * @param string $status
     * @param DateTime $terminationDate
     * @param string $agreementId
     */
    public function __construct(int $id, string $type, string $description, DateTime $startDate, string $status, DateTime $terminationDate, string $agreementId)
    {
        parent::__construct($id, $type, $description, $startDate);

        $this->id = $id;
        $this->description = $description;
        $this->startDate = $startDate;
        $this->status = $status;
        $this->terminationDate = $terminationDate;
        $this->agreementId = $agreementId;
    }
}
