<?php

namespace SHD\Smview\Connect\Domain\Telekom;

/**
 * Telekom MSISDNData Model
 *
 * @package    i-doit
 * @subpackage smview_connect
 * @author     Florian Weber <florian.weber@shd-online.de>
 * @copyright  2022 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
final class MSISDNData
{
    /**
     * @var string
     */
    public $type;

    /**
     * @var string
     */
    public $countryCode;

    /**
     * @var string
     */
    public $networkDestinationCode;

    /**
     * @var string
     */
    public $subscriberNumber;

    /**
     * @param string $type
     * @param string $countryCode
     * @param string $networkDestinationCode
     * @param string $subscriberNumber
     */
    public function __construct(string $type, string $countryCode, string $networkDestinationCode, string $subscriberNumber)
    {
        $this->type = $type;
        $this->countryCode = $countryCode;
        $this->networkDestinationCode = $networkDestinationCode;
        $this->subscriberNumber = $subscriberNumber;
    }

    /**
     * Get the full mobile number
     *
     * @return string
     */
    public function getMobileNumber(): string
    {
        return sprintf(
            '+%s%s%s',
            $this->countryCode,
            (str_starts_with($this->networkDestinationCode, '0')) ? substr($this->networkDestinationCode, 1, strlen($this->networkDestinationCode) - 1) : $this->networkDestinationCode,
            $this->subscriberNumber
        );
    }
}
