<?php

namespace SHD\Smview\Connect\Domain\Telekom;

use DateTime;

/**
 * Telekom Product Model
 *
 * @package    i-doit
 * @subpackage smview_connect
 * @author     Florian Weber <florian.weber@shd-online.de>
 * @copyright  2022 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class Product
{
    /**
     * @var string
     */
    public $id;

    /**
     * @var string
     */
    public $type;

    /**
     * @var string
     */
    public $description;

    /**
     * @var DateTime|null
     */
    public $startDate;

    /**
     * @var array<ProductRelationshipData>
     */
    public $productRelationship = [];

    /**
     * @param string $id
     * @param string $type
     * @param string|null $description
     * @param DateTime|null $startDate
     */
    public function __construct(string $id, string $type, ?string $description, ?DateTime $startDate)
    {
        $this->id = $id;
        $this->type = $type;
        $this->description = $description;
        $this->startDate = $startDate;
    }
}
