<?php

namespace SHD\Smview\Connect\Domain\Telekom;

use DateTime;

/**
 * Telekom ProductTermData Model
 *
 * @package    i-doit
 * @subpackage smview_connect
 * @author     Florian Weber <florian.weber@shd-online.de>
 * @copyright  2022 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
final class ProductTermData
{
    /**
     * @var string
     */
    public $type;

    /**
     * @var DateTime
     */
    public $validForStartDateTime;

    /**
     * @var float|null
     */
    public $durationAmount;

    /**
     * @var string|null
     */
    public $durationUnits;

    /**
     * @param string $type
     * @param DateTime $validForStartDateTime
     * @param float|null $durationAmount
     * @param string|null $durationUnits
     */
    public function __construct(string $type, DateTime $validForStartDateTime, ?float $durationAmount, ?string $durationUnits)
    {
        $this->type = $type;
        $this->validForStartDateTime = $validForStartDateTime;
        $this->durationAmount = $durationAmount;
        $this->durationUnits = $durationUnits;
    }
}
