<?php

namespace SHD\Smview\Connect\Domain\Telekom;

/**
 * Telekom RelatedParty Model
 *
 * @package    i-doit
 * @subpackage smview_connect
 * @author     Florian Weber <florian.weber@shd-online.de>
 * @copyright  2022 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
final class RelatedParty
{
    /**
     * @var int
     */
    public $id;

    /**
     * @var string
     */
    public $role;

    /**
     * @var string
     */
    public $nameType;

    /**
     * @var string
     */
    public $organizationType;

    /**
     * @var string
     */
    public $tradingName;

    /**
     * @var string|null
     */
    public $department;

    /**
     * @var string
     */
    public $contactPerson;

    /**
     * @var string|null
     */
    public $vatId;

    /**
     * @var string|null
     */
    public $taxNumber;

    /**
     * @var string|null
     */
    public $affiliateNumber;

    //more fields about contact mediums are available if needed

    /**
     * @param int $id
     * @param string $role
     * @param string $nameType
     * @param string $organizationType
     * @param string $tradingName
     * @param string|null $department
     * @param string|null $contactPerson
     * @param string|null $vatId
     * @param string|null $taxNumber
     * @param string|null $affiliateNumber
     */
    public function __construct(int $id, string $role, string $nameType, string $organizationType, string $tradingName, ?string $department, ?string $contactPerson, ?string $vatId, ?string $taxNumber, ?string $affiliateNumber)
    {
        $this->id = $id;
        $this->role = $role;
        $this->nameType = $nameType;
        $this->organizationType = $organizationType;
        $this->tradingName = $tradingName;
        $this->department = $department;
        $this->contactPerson = $contactPerson;
        $this->vatId = $vatId;
        $this->taxNumber = $taxNumber;
        $this->affiliateNumber = $affiliateNumber;
    }
}
