<?php

namespace SHD\Smview\Connect\Domain\Telekom;

/**
 * Telekom SimCard Model
 *
 * @package    i-doit
 * @subpackage smview_connect
 * @author     Florian Weber <florian.weber@shd-online.de>
 * @copyright  2022 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
final class SimCard
{
    /**
     * @var string
     */
    public string $cardType;

    /**
     * @var string|null
     */
    public ?string $eSimProfileStatus;

    /**
     * @var string
     */
    public string $mode;

    /**
     * @var bool
     */
    public bool $noRing;

    /**
     * @var string
     */
    public string $referredType;

    /**
     * @var SimCardNumberDataInterface
     */
    public SimCardNumberDataInterface $cardNo;

    /**
     * @var string|null
     */
    public ?string $pin1 = null;

    /**
     * @var string|null
     */
    public ?string $pin2 = null;

    /**
     * @var string|null
     */
    public ?string $puk1 = null;

    /**
     * @var string|null
     */
    public ?string $puk2 = null;

    /**
     * @param string $cardType
     * @param string|null $eSimProfileStatus
     * @param string $mode
     * @param bool $noRing
     * @param string $referredType
     */
    public function __construct(string $cardType, ?string $eSimProfileStatus, string $mode, bool $noRing, string $referredType)
    {
        $this->cardType = $cardType;
        $this->eSimProfileStatus = $eSimProfileStatus;
        $this->mode = $mode;
        $this->noRing = $noRing;
        $this->referredType = $referredType;
    }
}
