<?php

namespace SHD\Smview\Connect\Domain\Vsphere;

use SHD\Smview\Connect\Domain\idoit\TransferObjectInterface;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class VsphereVm implements TransferObjectInterface
{
    public const POWER_STATE_OFF = 'POWERED_OFF';
    public const POWER_STATE_ON = 'POWERED_ON';

    /**
     * @var string  vm
     */
    public string $id;

    /**
     * @var string  name
     */
    public string $name;

    /**
     * @var string  power_state
     */
    public string $powerState;

    /**
     * @var int     cpu_count
     */
    public int $cpuCount;

    /**
     * @var int     memory_size_MiB
     */
    public int $memorySize;

    /**
     * @var string|null
     */
    public ?string $osName = null;

    /**
     * @var string|null
     */
    public ?string $osFullName = null;

    /**
     * @var string|null
     */
    public ?string $osFamily = null;

    /**
     * @var string|null
     */
    public ?string $hostName = null;

    /**
     * @var string|null
     */
    public ?string $ip = null;

    /**
     * @var int|null
     */
    public ?int $coresPerSocket = null;
}
