<?php

namespace SHD\Smview\Connect\Domain\idoit;

use Exception;
use isys_cmdb_dao_category_g_cpu;
use isys_exception_dao;
use isys_exception_database;
use isys_import_handler_cmdb;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class CpuCategoryData extends IdoitCategoryData
{
    public const TITLE = 'title';
    public const CORES = 'cores';

    /**
     * @param IdoitObject $item
     * @return IdoitCategoryDataInterface
     * @throws isys_exception_dao
     * @throws isys_exception_database
     * @throws Exception
     */
    public function syncDataTo(IdoitObject $item): IdoitCategoryDataInterface
    {
        $dao = isys_cmdb_dao_category_g_cpu::instance($this->getDatabase());

        $props = $this->extractFilledData([
            self::TITLE => self::TITLE,
            self::CORES => self::CORES,
        ]);

        $dao->clear_data($item->getId(), $dao->get_table());
        $dao->sync([
            'properties' => $props,
        ], $item->getId(), isys_import_handler_cmdb::C__CREATE);

        return $this;
    }
}
