<?php

namespace SHD\Smview\Connect\Domain\idoit;

use SHD\Smview\Connect\Service\DB\DaoUtil;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class DynamicCategoryData implements IdoitCategoryDataInterface
{
    private $value;
    private DynamicValueAssignment $assignment;
    private ?DynamicValueAssignment $compare;
    private ?DynamicValueAssignment $compareProp;
    private $matchingValue;

    /**
     * @param $value
     * @param DynamicValueAssignment $assignment
     * @param DynamicValueAssignment|null $compare
     * @param DynamicValueAssignment|null $compareProp
     * @param $matchingValue
     */
    public function __construct($value, DynamicValueAssignment $assignment, ?DynamicValueAssignment $compare, ?DynamicValueAssignment $compareProp, $matchingValue)
    {
        $this->value = $value;
        $this->assignment = $assignment;
        $this->compare = $compare;
        $this->compareProp = $compareProp;
        $this->matchingValue = $matchingValue;
    }

    /**
     * @param IdoitObject $item
     * @return IdoitCategoryDataInterface
     * @throws \isys_exception_database
     * @throws \isys_exception_general
     * @throws \isys_exception_validation
     */
    public function syncDataTo(IdoitObject $item): IdoitCategoryDataInterface
    {
        DaoUtil::writeDynamicCategoryData(
            $this->assignment->toArray(),
            $this->value,
            ['isys_obj__id' => $item->getId()],
            $this->compareProp->property_key,
            ($this->compare) ? $this->compare->toArray() : null,
            $this->matchingValue,
        );

        return $this;
    }
}
