<?php

namespace SHD\Smview\Connect\Domain\idoit;

use Exception;
use isys_cmdb_dao_category_g_memory;
use isys_exception_database;
use isys_exception_validation;
use isys_import_handler_cmdb;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class MemoryCategoryData extends IdoitCategoryData
{
    public const CAPACITY = 'capacity';
    public const UNIT = 'unit';

    /**
     * @param IdoitObject $item
     * @return IdoitCategoryDataInterface
     * @throws isys_exception_database
     * @throws isys_exception_validation
     * @throws Exception
     */
    public function syncDataTo(IdoitObject $item): IdoitCategoryDataInterface
    {
        $dao = isys_cmdb_dao_category_g_memory::instance($this->getDatabase());

        $props = $this->extractFilledData([
            self::CAPACITY => self::CAPACITY,
            self::UNIT => self::UNIT,
        ]);

        $dao->clear_data($item->getId(), $dao->get_table());
        $dao->sync([
            'properties' => $props,
        ], $item->getId(), isys_import_handler_cmdb::C__CREATE);

        return $this;
    }
}
