<?php

namespace SHD\Smview\Connect\Domain\idoit;

use isys_cmdb_dao_category_s_person_master;
use isys_import_handler_cmdb;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class PersonCategoryData extends IdoitCategoryData
{
    public const MAIL = 'mail';
    public const PHONE = 'phone_company';
    public const MOBILE = 'phone_mobile';
    public const FIRST_NAME = 'first_name';
    public const LAST_NAME = 'last_name';
    public const JOB_FUNCTION = 'function';
    public const DEPARTMENT = 'department';
    public const STREET = 'street';
    public const CITY = 'city';
    public const ZIP_CODE = 'zip_code';
    public const ORGANIZATION = 'organization';
    public const LDAP_DN = 'ldap_dn';
    public const LDAP_ID = 'ldap_id';

    public function syncDataTo(IdoitObject $item): IdoitCategoryDataInterface
    {
        $dao = isys_cmdb_dao_category_s_person_master::instance($this->getDatabase());
        $dao->set_object_id($item->getId());

        $catdata = new \isys_array([]);
        $dao->category_data($catdata, C__RECORD_STATUS__NORMAL);

        $importType = isys_import_handler_cmdb::C__CREATE;
        $dataId = null;

        if(count($catdata->toArray()) > 0) {
            $dataId = array_keys($catdata->toArray())[0];
            $importType = isys_import_handler_cmdb::C__UPDATE;
        }

        $_data = [];

        if($dataId > 0 && $importType == isys_import_handler_cmdb::C__UPDATE) {
            foreach ($dao->get_properties() as $p => $info) {
                $_data[$p] = $catdata->get($dataId)[$p] ?? null;
            }
        } else {
            foreach ($dao->get_properties() as $p => $info) {
                $_data[$p] = null;
            }
        }

        $props = [];

        //alles durchgehen und an der richtigen stelle mit neuem wert updaten
        foreach ($_data as $_prop_key => $_prop_value) {
            $_val = $_prop_value->m_id ?? $_prop_value->m_value ?? null;

            if(@$this->data[$_prop_key]) {
                $_val = $this->data[$_prop_key];
            }

            $props[$_prop_key] = ['value' => $_val];
        }

        $dao->sync([
            'data_id' => $dataId,
            'properties' => $props,
        ], $item->getId(), $importType);

        return $this;
    }
}
