<?php

namespace SHD\Smview\Connect\Domain\idoit\Property\Type;

use idoit\Component\Property\Type\TextProperty;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class JsonProperty extends TextProperty
{
    /**
     * @var bool
     */
    protected bool $visible;

    public function __construct($uiId, $title, $dataField, $sourceTable, $status = C__RECORD_STATUS__NORMAL, $formatCallback = [])
    {
        parent::__construct($uiId, $title, $dataField, $sourceTable, $status, $formatCallback);

        $this->getData()->setReadOnly(true);
    }

    /**
     * @return bool
     */
    public function isVisible(): bool
    {
        return $this->visible;
    }

    /**
     * @param bool $visible
     * @return JsonProperty
     */
    public function setVisible(bool $visible): JsonProperty
    {
        $this->visible = $visible;

        return $this;
    }
}
