<?php

namespace SHD\Smview\Connect\Service\Cache;

use DateTime;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
interface CacheInterface
{
    public function set($data, ?DateTime $invalidateBy): CacheInterface;
    public function get();
    public function isValid(): bool;
    public function hasCache(): bool;
    public function getKey(): string;
    public function getCacheDir(): string;
    public function getInvalidateBy(): ?DateTime;
}
