<?php

namespace SHD\Smview\Connect\Service;

/**
 * Exporter Interface
 *
 * @package    i-doit
 * @subpackage smview_connect
 * @author     Steve Gröber <steve.groeber@shd-online.de>
 * @copyright  2023 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
interface ExporterInterface
{
    /**
     * Main Exporter Method
     *
     * @return array
     */
    public function export(): array;

    /**
     * Api is Online or Offline
     *
     * @param int|null $profileId
     *
     * @return bool
     */
    public function status(?int $profileId): bool;

    /**
     * Get exporter name.
     *
     * @return string
     */
    public function getName(): string;

    /**
     * Check if exporter is licensed.
     *
     * @return bool
     */
    public function isLicensed(): bool;
}
