<?php

namespace SHD\Smview\Connect\Service\Gcache;

use isys_application;
use isys_module_shd_smview_connect;
use SHD\Smview\Connect\DAO\ProfileDAO;
use SHD\Smview\Connect\Service\AbstractConfiguration;
use SHD\Smview\Connect\Service\ConfigurationSettingsKey;
use SHD\Smview\Connect\Service\DB\DaoUtil;

class GcacheConfiguration extends AbstractConfiguration
{
    public const LICENSE_KEY = 'gcache';

    public const SETTING_CSV_PATH = 'csv.path';
    public const SETTING_CSV_CRON = 'csv.cron';

    public static function registerDI(): void
    {
        $importer = new Importer();
        isys_application::instance()->container->set('smview_connect.gcache.importer', $importer);
    }

    public static function getProfiles(): array
    {
        return DaoUtil::allRows(ProfileDAO::getInstance()->get_data(null, isys_module_shd_smview_connect::CONNECT_MODULE_GCACHE)) ?? [];
    }

    /**
     * @return array
     * @throws \isys_exception_general
     */
    public function getSettingsKeys(): array
    {
        $lang = isys_application::instance()->container->get('language');

        return [
            ConfigurationSettingsKey::set(self::SETTING_CSV_PATH, $lang->get('LC__CMDB__SMVIEW_CONNECT__CSV_PATH'), ConfigurationSettingsKey::TYPE_TEXT)->toArray(),
            ConfigurationSettingsKey::set(self::SETTING_CSV_CRON, $lang->get('LC__CMDB__SMVIEW_CONNECT__CRON'), ConfigurationSettingsKey::TYPE_CRON)->toArray(),
        ];
    }

    public function getRules(): array
    {
        return [];
    }

    public function save_config(array $postedData)
    {
    }

    public function export_config()
    {
    }
}
