<?php

namespace SHD\Smview\Connect\Service\Import\ValuePipeline;

use isys_cmdb_dao_object;
use SHD\Smview\Connect\Service\DB\DaoUtil;

class ObjectService implements ValuePiplineUtilityServiceInterface
{
    private isys_cmdb_dao_object $dao;

    public function __construct(isys_cmdb_dao_object $dao)
    {
        $this->dao = $dao;
    }

    /**
     * @param int $typeId
     * @param array $conditions
     * @return array
     * @throws \isys_exception_database
     */
    public function findObjects(int $typeId, array $conditions): array
    {
        $sql = <<<SQL
select	o.isys_obj__id
FROM	isys_obj o
SQL;

        $join = '';
        $where = 'where	o.isys_obj__isys_obj_type__id = '.$typeId.' ';

        $count = 0;

        foreach ($conditions as $condition) {
            if(stripos($condition['category'], 'C__CATG__CUSTOM_FIELDS_') !== false) { //custom cat
                $join .= "join isys_catg_custom_fields_list cf".$count." on o.isys_obj__id = cf".$count.".isys_catg_custom_fields_list__isys_obj__id";

                $where .= "and (cf".$count.".isys_catg_custom_fields_list__field_key = '"
                    .$condition['property']
                    ."' and cf".$count.".isys_catg_custom_fields_list__isysgui_catg_custom__id = (select isysgui_catg_custom__id from isysgui_catg_custom where isysgui_catg_custom__const = '"
                    .$condition['category'].
                    "')"
                    ." and cf".$count.".isys_catg_custom_fields_list__field_content "
                    .$condition['comparison']
                    ." '"
                    .$condition['value']
                    ."')";
            } else {
                if(stripos($condition['category'], 'C__CATG_') !== false) {
                    $table = DaoUtil::getCategorySourceTable($condition['category']);

                    if(!$table) {
                        continue;
                    }
                } else {
                    $table = DaoUtil::getCategorySourceTable($condition['category'], false);

                    if(!$table) {
                        continue;
                    }
                }

                $join .= "join ".$table." cat".$count." on o.isys_obj__id = cat".$count.".".$table."__isys_obj__id";

                $where .= "and (cat".$count.".".$table."__".$condition['property']." ".$condition['comparison']." '".$condition['value']."')";
            }

            $count++;
        }

        $sql .= ' '.$join.PHP_EOL.$where;

        $result = DaoUtil::allRows($this->dao->retrieve($sql)) ?? [];
        $ids = array_map(function($el) {
            return $el['isys_obj__id'];
        }, $result);

        return array_unique($ids);
    }
}
