<?php

namespace SHD\Smview\Connect\Service;

/**
 * Importer Interface
 *
 * @package    i-doit
 * @subpackage smview_connect
 * @author     Florian Weber <florian.weber@shd-online.de>
 * @copyright  2022 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
interface ImporterInterface
{
    /**
     * Main Importer Method
     *
     * @return array
     */
    public function import(): array;

    /**
     * Api is Online or Offline
     *
     * @param int|null $profileId
     * @return bool
     */
    public function status(?int $profileId = null): bool;

    public function getName(): string;

    public function isLicensed(): bool;
    public function isEnabled(): bool;
    public function getProfileId(): ?int;
}
