<?php

namespace SHD\Smview\Connect\Service\Mapping;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class Mapper
{
    public const MODE_DEFAULT = 'default';
    public const MODE_CUSTOM_DIALOGPLUS = 'custom_dialog+';

    /**
     * @var string
     */
    private $mappingTransformer;

    private string $mode;
    private array $parameters;

    /**
     * @param string $mappingTransformer
     * @param string $mode
     * @param array $parameters
     */
    public function __construct(string $mappingTransformer, string $mode = self::MODE_DEFAULT, array $parameters = [])
    {
        $this->mappingTransformer = $mappingTransformer;
        $this->mode = $mode;
        $this->parameters = $parameters;
    }

    /**
     * Convert the Input Data to the Mapped Data
     *
     * @param MappingDefinitionInterface $definition
     * @return MappingDefinitionInterface
     */
    public function get(MappingDefinitionInterface $definition): MappingDefinitionInterface
    {
        /** @var MappingTransformerInterface $transformer */
        $transformer = new $this->mappingTransformer();

        return $transformer->handle($definition, $this->mode, $this->parameters);
    }
}
