<?php

namespace SHD\Smview\Connect\Service\Mapping;

use SHD\Smview\Connect\DAO\DataMappingDAO;
use SHD\Smview\Connect\Service\DB\DaoUtil;
use isys_exception_dao;
use isys_exception_database;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
abstract class Transformer implements MappingTransformerInterface
{
    /**
     * @param string $identifier
     * @param string $title
     * @return int
     * @throws isys_exception_dao
     * @throws isys_exception_database
     */
    protected function getOrCreateCustomDialogPlusValue(string $identifier, string $title): int
    {
        $id = DaoUtil::getCustomDialogPlusId($identifier, $title);

        if(!$id) { //create
            $id = DaoUtil::createCustomDialogPlusId($identifier, $title);
        }

        return $id;
    }

    public function map(string $type, string $str): string
    {
        $mapping = DaoUtil::allRows(DataMappingDAO::getInstance()->get_data($type, $str))[0] ?? null;

        if($mapping != null) {
            return $mapping['target'];
        }

        return $str;
    }
}
