<?php

namespace SHD\Smview\Connect\Service\Mapping\Transformer;

use SHD\Smview\Connect\Service\Mapping\Definition\GenericCustomMappingDefinition;
use SHD\Smview\Connect\Service\Mapping\Mapper;
use SHD\Smview\Connect\Service\Mapping\MappingDefinitionInterface;
use SHD\Smview\Connect\Service\Mapping\Transformer;
use isys_exception_dao;
use isys_exception_database;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class GenericCustomMappingTransformer extends Transformer
{
    /**
     * @param GenericCustomMappingDefinition $defintion
     * @param string $mode
     * @param array $parameters
     * @return MappingDefinitionInterface
     * @throws isys_exception_dao
     * @throws isys_exception_database
     */
    public function handle(MappingDefinitionInterface $defintion, string $mode = Mapper::MODE_DEFAULT, array $parameters = []): MappingDefinitionInterface
    {
        $defintion->id = $this->getOrCreateCustomDialogPlusValue($parameters['identifier'], $this->map($defintion->type, $defintion->value));

        return $defintion;
    }
}
