<?php

namespace SHD\Smview\Connect\Service;

class RawDataDumper
{
    public static function getShouldDumpRawResult(): bool
    {
        return \isys_module_shd_smview_connect::isDevMode();
    }

    public static function dumpRawResult(string $base, string $section, string $rawContent, array $subsections = []): void
    {
        $dir = \isys_module_shd_smview_connect::getIdoitDir().'/raw_dumps/'.$base;

        if(!is_dir($dir)) {
            mkdir($dir, 0777, true);
        }

        $filename = $dir.'/'.$section;

        if(count($subsections) > 0) {
            $filename = $filename.'_'.implode('_', $subsections).'.json';
        } else {
            $filename = $filename.'.json';
        }

        file_put_contents($filename, $rawContent);
    }
}
