<?php

namespace idoit\Module\Shdsmviewconnect\Controller;

use SHD\Smview\Connect\Service\Rest\InstallManager;
use idoit\Module\Shdsmviewconnect\View\Rest\SettingsView;
use idoit\View\Renderable;
use isys_application;
use isys_register;

class Rest extends AddonController
{
    /**
     * @param isys_register $p_request
     * @param isys_application $p_application
     * @return Renderable
     */
    public function handle(isys_register $p_request, isys_application $p_application)
    {
        return $this->settings($p_request);
    }

    public function settings(isys_register $request): Renderable
    {
        if(intval($request->get('POST')->get('INSTALL')) == 1) {
            InstallManager::installFrontController();
        }

        if(intval($request->get('POST')->get('INSTALL_HTE')) == 1 && !InstallManager::hasHtaccessExemption()) {
            InstallManager::installHtaccessExemption();
        }

        return new SettingsView($request);
    }
}
