<?php

namespace idoit\Module\Shdsmviewconnect\View\Main;

use SHD\Smview\Connect\Service\CacheManager;
use idoit\Model\Dao\Base as DaoBase;
use idoit\View\Base as ViewBase;
use idoit\View\Renderable;
use isys_application;
use isys_component_template as ComponentTemplate;
use isys_exception_general;
use isys_module as Module;
use isys_module_shd_smview_connect;
use Monolog\Logger;

/**
 * Cache Overview View
 *
 * @package    i-doit
 * @subpackage smview_connect
 * @author     Florian Weber <florian.weber@shd-online.de>
 * @copyright  2023 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class CacheOverviewView extends ViewBase
{
    public function process(Module $module, ComponentTemplate $template, DaoBase $model): Renderable
    {
        /** @var CacheManager $cacheManager */
        $cacheManager = isys_application::instance()->container->get('smview_connect.cache');
        $apiCaches = $cacheManager->getCaches(isys_module_shd_smview_connect::getParameter('smview_connect.api_cache_dir'));

        $template->assign('api_caches', $apiCaches);

        $this->paths['contentbottomcontent'] = isys_module_shd_smview_connect::getPath().'templates/main/cache_overview.tpl';

        return $this;
    }
}
