<?php

namespace idoit\Module\Shdsmviewconnect\View\Main;

use idoit\Model\Dao\Base as DaoBase;
use idoit\Module\Shdsmviewconnect\View\BaseView;
use isys_component_template as ComponentTemplate;
use isys_module as Module;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class DevPropsView extends BaseView
{
    public function process(Module $module, ComponentTemplate $template, DaoBase $model)
    {
        if(!str_starts_with($this->data['class'], 'isys_')) {
            throw new \isys_exception_general('class has to start with isys_');
        }

        $db = \isys_application::instance()->container->get('database');

        /** @var \isys_cmdb_dao_category $dao */
        $dao = call_user_func($this->data['class'].'::instance', $db);

        if($this->data['id']) {
            $dao->set_object_id($this->data['id']);
        }

        dump($dao->get_properties());
    }
}
