<?php

namespace idoit\Module\Shdsmviewconnect\View\Main;

use SHD\Smview\Connect\Service\ShdLicense;
use idoit\View\Base as ViewBase;
use idoit\Model\Dao\Base as DaoBase;
use idoit\View\Renderable;
use isys_auth;
use isys_auth_auth;
use isys_component_template as ComponentTemplate;
use isys_module as Module;
use isys_module_shd_smview_connect;

/**
 * License Upload View
 *
 * @package    i-doit
 * @subpackage smview_connect
 * @author     Florian Weber <florian.weber@shd-online.de>
 * @copyright  2022 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class LicenseUploadView extends ViewBase
{
    /**
     * @param Module $module
     * @param ComponentTemplate $template
     * @param DaoBase $model
     * @return Renderable
     */
    public function process(Module $module, ComponentTemplate $template, DaoBase $model): Renderable
    {
        $canEdit = isys_auth_auth::instance()->is_allowed_to(isys_auth::EDIT, 'MODULE/C__MODULE__SHD_SMVIEW_CONNECT');

        if($canEdit) {
            $template->activate_editmode();
        }

        $license = new ShdLicense();

        $template
            ->assign('license', $license)
            ->assign('assets_dir', isys_module_shd_smview_connect::get_assets_www_dir())
            ->assign('image_url', isys_module_shd_smview_connect::getAppDir().'/images/icons/silk/')
            ->assign('encType', 'multipart/form-data')
        ;

        $this->paths['contentbottomcontent'] = isys_module_shd_smview_connect::getPath().'templates/main/license_upload.tpl';

        return $this;
    }
}
