<?php

namespace idoit\Module\Shdsmviewconnect\View\Main;

use Exception;
use idoit\View\Base as ViewBase;
use idoit\Model\Dao\Base as DaoBase;
use idoit\View\Renderable;
use isys_application;
use isys_component_template as ComponentTemplate;
use isys_module as Module;
use isys_module_shd_smview_connect;

/**
 * Logging View
 *
 * @package    i-doit
 * @subpackage smview_connect
 * @author     Florian Weber <florian.weber@shd-online.de>
 * @copyright  2022 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class LoggingView extends ViewBase
{
    /**
     * @param Module $module
     * @param ComponentTemplate $template
     * @param DaoBase $model
     * @return Renderable
     * @throws Exception
     */
    public function process(Module $module, ComponentTemplate $template, DaoBase $model): Renderable
    {
        $logger = isys_application::instance()->container->get('smview_connect.logger');
        $template->assign('logs', $logger->getLogs(4));

        $this->paths['contentbottomcontent'] = isys_module_shd_smview_connect::getPath().'templates/main/logging.tpl';

        return $this;
    }
}
