<?php

namespace idoit\Module\Shdsmviewconnect\View\Telekom;

use SHD\Smview\Connect\DAO\ProfileDAO;
use SHD\Smview\Connect\Service\DB\DaoUtil;
use SHD\Smview\Connect\Service\Telekom\TelekomConfiguration;
use idoit\View\Base as ViewBase;
use idoit\Model\Dao\Base as DaoBase;
use idoit\View\Renderable;
use isys_application;
use isys_auth;
use isys_auth_auth;
use isys_component_template as ComponentTemplate;
use isys_module as Module;
use isys_module_shd_smview_connect;

/**
 * @author Florian Weber <florian.weber@shd-online.de>
 */
class DevDataView extends ViewBase
{
    public array $data = [];

    public function process(Module $module, ComponentTemplate $template, DaoBase $model): Renderable
    {
        $canEdit = isys_auth_auth::instance()->is_allowed_to(isys_auth::EDIT, 'MODULE/C__MODULE__SHD_SMVIEW_CONNECT');

        if($canEdit) {
            $template->activate_editmode();
        }

        /** @var TelekomConfiguration $telekomConfig */
        $telekomConfig = isys_application::instance()->container->get('smview_connect.telekom.config');

        $rules = $telekomConfig->getRules();
        $profiles = DaoUtil::allRows(ProfileDAO::getInstance()->get_data(null, isys_module_shd_smview_connect::CONNECT_MODULE_TELEKOM));

        $template
            ->assign('profiles', $profiles)
            ->assign('assets_dir', isys_module_shd_smview_connect::get_assets_www_dir())
            ->assign('image_url', isys_module_shd_smview_connect::getAppDir().'/images/icons/silk/')
            ->assign('encType', 'multipart/form-data')
            ->assign('context', $this->data)
            ->smarty_tom_add_rules("tom.content.bottom.content", $rules);

        $this->paths['contentbottomcontent'] = isys_module_shd_smview_connect::getPath().'templates/telekom/dev_data.tpl';

        return $this;
    }
}
