<?php

namespace idoit\Module\Shdsmviewconnect\View\Telekom;

use Exception;
use idoit\View\Base as ViewBase;
use idoit\Model\Dao\Base as DaoBase;
use idoit\View\Renderable;
use isys_component_template as ComponentTemplate;
use isys_module as Module;
use isys_module_shd_smview_connect;

/**
 * Telekom Token View
 *
 * @package    i-doit
 * @subpackage smview_connect
 * @author     Florian Weber <florian.weber@shd-online.de>
 * @copyright  2022 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class TokenView extends ViewBase
{
    public $profiles = [];

    /**
     * @param Module $module
     * @param ComponentTemplate $template
     * @param DaoBase $model
     * @return Renderable
     * @throws Exception
     */
    public function process(Module $module, ComponentTemplate $template, DaoBase $model): Renderable
    {
        $template
            ->assign('image_url', isys_module_shd_smview_connect::getAppDir().'/images/icons/silk/')
            ->assign('profiles', $this->profiles)
        ;

        $this->paths['contentbottomcontent'] = isys_module_shd_smview_connect::getPath().'templates/telekom/token.tpl';

        return $this;
    }
}
