<?php

namespace idoit\Module\Shdsmviewconnect\View\ValuePipeline;

use idoit\View\Base as ViewBase;
use idoit\Model\Dao\Base as DaoBase;
use idoit\View\Renderable;
use isys_component_template as ComponentTemplate;
use isys_module as Module;
use isys_module_shd_smview_connect;

/**
 * ValuePipeline View
 *
 * @package    i-doit
 * @subpackage smview_connect
 * @author     Florian Weber <florian.weber@shd-online.de>
 * @copyright  2023 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class SettingsView extends ViewBase
{
    /**
     * @param Module $module
     * @param ComponentTemplate $template
     * @param DaoBase $model
     * @return Renderable
     */
    public function process(Module $module, ComponentTemplate $template, DaoBase $model): Renderable
    {
        $rules = [];

        $template
            ->smarty_tom_add_rules("tom.content.bottom.content", $rules);

        $this->paths['contentbottomcontent'] = isys_module_shd_smview_connect::getPath().'templates/value_pipeline/settings.tpl';

        return $this;
    }
}
