<style>
    .hidden {
        display: none;
    }
</style>
<link href="[{$assets_dir}]dist/mapping_editor/style.css" rel="stylesheet">

<h3 class="p5 gradient border-bottom">
    [{isys type='lang' ident='LC__CMDB__SMVIEW_CONNECT__ADAPTER_AZURE'}]
</h3>

<fieldset class="overview">
    <legend>
        <span>[{isys type='lang' ident='LC__CMDB__SMVIEW_CONNECT__CONNECT_AZURE_SETTINGS'}]</span>
    </legend>
    <div style="padding: 10px;">
        <table class="contentTable">
            <tr>
                <td class="key">[{isys type='f_label' name='C__SMVIEW_CONNECT__AZURE_CRON' ident='LC__CMDB__SMVIEW_CONNECT__CRON'}]</td>
                <td class="value">
                    [{isys type='f_text' name='C__SMVIEW_CONNECT__AZURE_CRON'}]
                </td>
                <td class="value">
                    <a href="https://crontab-generator.org/" target="_blank">Crontab Generator</a>
                </td>
            </tr>
        </table>
    </div>
</fieldset>

<fieldset class="overview">
    <legend>
        <span>[{isys type='lang' ident='LC__CMDB__SMVIEW_CONNECT__CONNECT_AZURE_ACTIONS'}]</span>
    </legend>
    <div style="padding: 10px;">
        <table class="contentTable">
            <tr>
                <td class="key">&nbsp;</td>
                <td class="value">
                    <button id="start_import" type="button" class="btn">[{isys type='lang' ident='LC__CMDB__SMVIEW_CONNECT__START_IMPORT'}]</button>
                    <button id="load_defaults" type="button" class="btn">[{isys type='lang' ident='LC__CMDB__SMVIEW_CONNECT__LOAD_DEFAULTS'}]</button>
                </td>
            </tr>
            <tr>
                <td class="key">&nbsp;</td>
                <td class="value">
                    <img id="spinner" class="hidden" src="[{$spinner_url}]" alt="Loading..." />
                </td>
            </tr>
            <tr>
                <td class="key">&nbsp;</td>
                <td id="log" class="value">&nbsp;</td>
            </tr>
        </table>
    </div>
</fieldset>

<script type="text/javascript" src="[{$assets_dir}]dist/vendors.js"></script>

<div id="editor">
    Loading...
</div>
<input type="hidden" id="C__CATG__SMVIEW_REACT_CONFIG" name="C__CATG__SMVIEW_REACT_CONFIG" value='[{$js_config}]' />
<input type="hidden" id='[{$profile_ui}]' name='[{$profile_ui}]' value='[{$profile_id}]' />
<script type="text/javascript">
    (function () {
        "use strict";

        setTimeout(function() {
            if (! $('mapping_editor')) {
                // load mapping editor dynamically to avoid re-rendering problems
                var mapping_editor_script = document.createElement('script');
                mapping_editor_script.setAttribute('src','[{$assets_dir}]dist/mapping_editor/mapping_editor.js');
                document.head.appendChild(mapping_editor_script);
            }
        }, 1000);
    }());
</script>

<script type="text/javascript">
    $('start_import').on('click', function(event) {
        $('start_import').setAttribute('disabled', 'disabled');
        $('spinner').toggleClassName('hidden');
        $('log').innerHTML = '';

        let url = '[{$ajax_url}]&func=import_azure';
        new Ajax.Request(url, {
            onSuccess: function (response) {
                $('start_import').removeAttribute('disabled');
                $('spinner').toggleClassName('hidden');
                let json = JSON.parse(response.responseText);
                $('log').innerHTML = json.message;
            },
            onFailure: function (response) {
                $('start_import').removeAttribute('disabled');
                $('spinner').toggleClassName('hidden');
                $('log').innerHTML = 'error';
            }
        });
    });

    $('load_defaults').on('click', function(event) {
        $('load_defaults').setAttribute('disabled', 'disabled');
        $('spinner').toggleClassName('hidden');
        $('log').innerHTML = '';

        let url = '[{$ajax_url}]&func=defaults_azure';
        new Ajax.Request(url, {
            onSuccess: function (response) {
                $('load_defaults').removeAttribute('disabled');
                $('spinner').toggleClassName('hidden');
                let json = JSON.parse(response.responseText);
                $('log').innerHTML = json.message;
            },
            onFailure: function (response) {
                $('load_defaults').removeAttribute('disabled');
                $('spinner').toggleClassName('hidden');
                $('log').innerHTML = 'error';
            }
        });
    });
</script>
