<?php

namespace SHD\Smview\Connect\Service;

use PHPUnit\Framework\TestCase;

/**
 * @covers \SHD\Smview\Connect\Service\ConfigurationObjectTypeMappingKey
 */
class ConfigurationObjectTypeMappingKeyTest extends TestCase
{
    /**
     * @depends testToArray
     */
    public function testSet()
    {
        $key = ConfigurationObjectTypeMappingKey::set('foo', 'bar');
        $a = $key->toArray();

        $this->assertEquals('foo', $a['property_key']);
        $this->assertEquals('bar', $a['label']);
    }

    public function testToArray()
    {
        $key = new ConfigurationObjectTypeMappingKey('foo', 'bar');
        $a = $key->toArray();

        $this->assertIsArray($a);
        $this->assertArrayHasKey('property_key', $a);
        $this->assertArrayHasKey('label', $a);
        $this->assertEquals('foo', $a['property_key']);
        $this->assertEquals('bar', $a['label']);
    }
}
