<?php

namespace SHD\Smview\Connect\Service;

use PHPUnit\Framework\TestCase;

/**
 * @covers \SHD\Smview\Connect\Service\ConfigurationSettingsKey
 */
class ConfigurationSettingsKeyTest extends TestCase
{
    /**
     * @depends testToArray
     */
    public function testSet()
    {
        $key = ConfigurationSettingsKey::set('foo', 'bar', ConfigurationSettingsKey::TYPE_TEXT, false, 'baz');
        $a = $key->toArray();

        $this->assertEquals('foo', $a['key']);
        $this->assertEquals('bar', $a['label']);
        $this->assertEquals('text', $a['typeName']);
        $this->assertFalse($a['visible']);
        $this->assertEquals('baz', $a['value']);
    }

    public function testToArray()
    {
        $key = new ConfigurationSettingsKey('foo', 'bar', ConfigurationSettingsKey::TYPE_TEXT, false, 'baz');
        $a = $key->toArray();

        $this->assertIsArray($a);
        $this->assertArrayHasKey('key', $a);
        $this->assertArrayHasKey('label', $a);
        $this->assertArrayHasKey('typeName', $a);
        $this->assertArrayHasKey('visible', $a);
        $this->assertArrayHasKey('value', $a);

        $this->assertEquals('foo', $a['key']);
        $this->assertEquals('bar', $a['label']);
        $this->assertEquals('text', $a['typeName']);
        $this->assertFalse($a['visible']);
        $this->assertEquals('baz', $a['value']);

        $key = new ConfigurationSettingsKey('foo', 'bar', ConfigurationSettingsKey::TYPE_SELECT, true, ['foo' => 'bar']);
        $a = $key->toArray();

        $this->assertEquals('select', $a['typeName']);
        $this->assertJson($a['value']);

        $this->expectException(\isys_exception_general::class);
        $key = new ConfigurationSettingsKey('foo', 'bar', ConfigurationSettingsKey::TYPE_SELECT, true, 'fail');
    }
}
