<?php

namespace SHD\Smview\Connect\Service;

use PHPUnit\Framework\TestCase;

/**
 * @covers \SHD\Smview\Connect\Service\Cron
 */
class CronTest extends TestCase
{
    public function testGetDefaultCronList()
    {
        $this->assertCount(6, Cron::getDefaultCronList());
    }

    public function testGetDateTimeFromCron()
    {
        $now = new \DateTime();
        $dex = clone $now;

        if(intval($now->format('H')) >= 12 && intval($now->format('i')) > 0 && intval($now->format('s')) > 0) {
            $dex = $dex->modify('+1 day')->setTime(12, 0, 0);
        } else {
            $dex = $dex->setTime(12, 0, 0);
        }

        $dt = Cron::getDateTimeFromCron('0 12 * * *');

        $this->assertEquals($dex, $dt);

        $this->expectException(\InvalidArgumentException::class);
        Cron::getDateTimeFromCron('0 60 * * *');

        $this->expectException(\InvalidArgumentException::class);
        Cron::getDateTimeFromCron('');
    }

    public function testGetDefaultCronForNotConfigured()
    {
        $this->assertEquals('0 */6 * * *', Cron::getDefaultCronForNotConfigured());
    }
}
